1# Test framework for git. See t/README for usage.
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
17
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
33fi
34if test -z "$TEST_OUTPUT_DIRECTORY"
35then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39fi
40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
42################################################################
43# It appears that people try to run tests without building...
44"$GIT_BUILD_DIR/git" >/dev/null
45if test $? != 1
46then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
49fi
50
51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52export PERL_PATH SHELL_PATH
53
54# if --tee was passed, write the output not only to the terminal, but
55# additionally to the file test-results/$BASENAME.out, too.
56case "$GIT_TEST_TEE_STARTED, $* " in
57done,*)
58 # do not redirect again
59 ;;
60*' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
67 ;;
68esac
69
70# For repeatability, reset the environment to known value.
71LANG=C
72LC_ALL=C
73PAGER=cat
74TZ=UTC
75TERM=dumb
76export LANG LC_ALL PAGER TERM TZ
77EDITOR=:
78# A call to "unset" with no arguments causes at least Solaris 10
79# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80# deriving from the command substitution clustered with the other
81# ones.
82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
83 my @env = keys %ENV;
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
92 UNZIP
93 PERF_
94 ));
95 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
96 print join("\n", @vars);
97')
98unset XDG_CONFIG_HOME
99unset GITPERLLIB
100GIT_AUTHOR_EMAIL=author@example.com
101GIT_AUTHOR_NAME='A U Thor'
102GIT_COMMITTER_EMAIL=committer@example.com
103GIT_COMMITTER_NAME='C O Mitter'
104GIT_MERGE_VERBOSITY=5
105GIT_MERGE_AUTOEDIT=no
106export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
107export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
108export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
109export EDITOR
110
111if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
112then
113 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
114 export GIT_INDEX_VERSION
115fi
116
117# Add libc MALLOC and MALLOC_PERTURB test
118# only if we are not executing the test with valgrind
119if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
120 test -n "$TEST_NO_MALLOC_CHECK"
121then
122 setup_malloc_check () {
123 : nothing
124 }
125 teardown_malloc_check () {
126 : nothing
127 }
128else
129 setup_malloc_check () {
130 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
131 export MALLOC_CHECK_ MALLOC_PERTURB_
132 }
133 teardown_malloc_check () {
134 unset MALLOC_CHECK_ MALLOC_PERTURB_
135 }
136fi
137
138# Protect ourselves from common misconfiguration to export
139# CDPATH into the environment
140unset CDPATH
141
142unset GREP_OPTIONS
143unset UNZIP
144
145case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1461|2|true)
147 echo "* warning: Some tests will not work if GIT_TRACE" \
148 "is set as to trace on STDERR ! *"
149 echo "* warning: Please set GIT_TRACE to something" \
150 "other than 1, 2 or true ! *"
151 ;;
152esac
153
154# Convenience
155#
156# A regexp to match 5 and 40 hexdigits
157_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
158_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
159
160# Zero SHA-1
161_z40=0000000000000000000000000000000000000000
162
163# Line feed
164LF='
165'
166
167# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
168# when case-folding filenames
169u200c=$(printf '\342\200\214')
170
171export _x05 _x40 _z40 LF u200c
172
173# Each test should start with something like this, after copyright notices:
174#
175# test_description='Description of this test...
176# This test checks if command xyzzy does the right thing...
177# '
178# . ./test-lib.sh
179[ "x$ORIGINAL_TERM" != "xdumb" ] && (
180 TERM=$ORIGINAL_TERM &&
181 export TERM &&
182 [ -t 1 ] &&
183 tput bold >/dev/null 2>&1 &&
184 tput setaf 1 >/dev/null 2>&1 &&
185 tput sgr0 >/dev/null 2>&1
186 ) &&
187 color=t
188
189while test "$#" -ne 0
190do
191 case "$1" in
192 -d|--d|--de|--deb|--debu|--debug)
193 debug=t; shift ;;
194 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
195 immediate=t; shift ;;
196 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
197 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
198 -h|--h|--he|--hel|--help)
199 help=t; shift ;;
200 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
201 verbose=t; shift ;;
202 --verbose-only=*)
203 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
204 shift ;;
205 -q|--q|--qu|--qui|--quie|--quiet)
206 # Ignore --quiet under a TAP::Harness. Saying how many tests
207 # passed without the ok/not ok details is always an error.
208 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
209 --with-dashes)
210 with_dashes=t; shift ;;
211 --no-color)
212 color=; shift ;;
213 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
214 valgrind=memcheck
215 shift ;;
216 --valgrind=*)
217 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
218 shift ;;
219 --valgrind-only=*)
220 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
221 shift ;;
222 --tee)
223 shift ;; # was handled already
224 --root=*)
225 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
226 shift ;;
227 *)
228 echo "error: unknown test option '$1'" >&2; exit 1 ;;
229 esac
230done
231
232if test -n "$valgrind_only"
233then
234 test -z "$valgrind" && valgrind=memcheck
235 test -z "$verbose" && verbose_only="$valgrind_only"
236elif test -n "$valgrind"
237then
238 verbose=t
239fi
240
241if test -n "$color"
242then
243 say_color () {
244 (
245 TERM=$ORIGINAL_TERM
246 export TERM
247 case "$1" in
248 error)
249 tput bold; tput setaf 1;; # bold red
250 skip)
251 tput setaf 4;; # blue
252 warn)
253 tput setaf 3;; # brown/yellow
254 pass)
255 tput setaf 2;; # green
256 info)
257 tput setaf 6;; # cyan
258 *)
259 test -n "$quiet" && return;;
260 esac
261 shift
262 printf "%s" "$*"
263 tput sgr0
264 echo
265 )
266 }
267else
268 say_color() {
269 test -z "$1" && test -n "$quiet" && return
270 shift
271 printf "%s\n" "$*"
272 }
273fi
274
275error () {
276 say_color error "error: $*"
277 GIT_EXIT_OK=t
278 exit 1
279}
280
281say () {
282 say_color info "$*"
283}
284
285test "${test_description}" != "" ||
286error "Test script did not set test_description."
287
288if test "$help" = "t"
289then
290 printf '%s\n' "$test_description"
291 exit 0
292fi
293
294exec 5>&1
295exec 6<&0
296if test "$verbose" = "t"
297then
298 exec 4>&2 3>&1
299else
300 exec 4>/dev/null 3>/dev/null
301fi
302
303test_failure=0
304test_count=0
305test_fixed=0
306test_broken=0
307test_success=0
308
309test_external_has_tap=0
310
311die () {
312 code=$?
313 if test -n "$GIT_EXIT_OK"
314 then
315 exit $code
316 else
317 echo >&5 "FATAL: Unexpected exit with code $code"
318 exit 1
319 fi
320}
321
322GIT_EXIT_OK=
323trap 'die' EXIT
324
325# The user-facing functions are loaded from a separate file so that
326# test_perf subshells can have them too
327. "$TEST_DIRECTORY/test-lib-functions.sh"
328
329# You are not expected to call test_ok_ and test_failure_ directly, use
330# the test_expect_* functions instead.
331
332test_ok_ () {
333 test_success=$(($test_success + 1))
334 say_color "" "ok $test_count - $@"
335}
336
337test_failure_ () {
338 test_failure=$(($test_failure + 1))
339 say_color error "not ok $test_count - $1"
340 shift
341 printf '%s\n' "$*" | sed -e 's/^/# /'
342 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
343}
344
345test_known_broken_ok_ () {
346 test_fixed=$(($test_fixed+1))
347 say_color error "ok $test_count - $@ # TODO known breakage vanished"
348}
349
350test_known_broken_failure_ () {
351 test_broken=$(($test_broken+1))
352 say_color warn "not ok $test_count - $@ # TODO known breakage"
353}
354
355test_debug () {
356 test "$debug" = "" || eval "$1"
357}
358
359match_pattern_list () {
360 arg="$1"
361 shift
362 test -z "$*" && return 1
363 for pattern_
364 do
365 case "$arg" in
366 $pattern_)
367 return 0
368 esac
369 done
370 return 1
371}
372
373maybe_teardown_verbose () {
374 test -z "$verbose_only" && return
375 exec 4>/dev/null 3>/dev/null
376 verbose=
377}
378
379last_verbose=t
380maybe_setup_verbose () {
381 test -z "$verbose_only" && return
382 if match_pattern_list $test_count $verbose_only
383 then
384 exec 4>&2 3>&1
385 # Emit a delimiting blank line when going from
386 # non-verbose to verbose. Within verbose mode the
387 # delimiter is printed by test_expect_*. The choice
388 # of the initial $last_verbose is such that before
389 # test 1, we do not print it.
390 test -z "$last_verbose" && echo >&3 ""
391 verbose=t
392 else
393 exec 4>/dev/null 3>/dev/null
394 verbose=
395 fi
396 last_verbose=$verbose
397}
398
399maybe_teardown_valgrind () {
400 test -z "$GIT_VALGRIND" && return
401 GIT_VALGRIND_ENABLED=
402}
403
404maybe_setup_valgrind () {
405 test -z "$GIT_VALGRIND" && return
406 if test -z "$valgrind_only"
407 then
408 GIT_VALGRIND_ENABLED=t
409 return
410 fi
411 GIT_VALGRIND_ENABLED=
412 if match_pattern_list $test_count $valgrind_only
413 then
414 GIT_VALGRIND_ENABLED=t
415 fi
416}
417
418test_eval_ () {
419 # This is a separate function because some tests use
420 # "return" to end a test_expect_success block early.
421 eval </dev/null >&3 2>&4 "$*"
422}
423
424test_run_ () {
425 test_cleanup=:
426 expecting_failure=$2
427 setup_malloc_check
428 test_eval_ "$1"
429 eval_ret=$?
430 teardown_malloc_check
431
432 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
433 then
434 setup_malloc_check
435 test_eval_ "$test_cleanup"
436 teardown_malloc_check
437 fi
438 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
439 then
440 echo ""
441 fi
442 return "$eval_ret"
443}
444
445test_start_ () {
446 test_count=$(($test_count+1))
447 maybe_setup_verbose
448 maybe_setup_valgrind
449}
450
451test_finish_ () {
452 echo >&3 ""
453 maybe_teardown_valgrind
454 maybe_teardown_verbose
455}
456
457test_skip () {
458 to_skip=
459 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
460 then
461 to_skip=t
462 fi
463 if test -z "$to_skip" && test -n "$test_prereq" &&
464 ! test_have_prereq "$test_prereq"
465 then
466 to_skip=t
467 fi
468 case "$to_skip" in
469 t)
470 of_prereq=
471 if test "$missing_prereq" != "$test_prereq"
472 then
473 of_prereq=" of $test_prereq"
474 fi
475
476 say_color skip >&3 "skipping test: $@"
477 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
478 : true
479 ;;
480 *)
481 false
482 ;;
483 esac
484}
485
486# stub; perf-lib overrides it
487test_at_end_hook_ () {
488 :
489}
490
491test_done () {
492 GIT_EXIT_OK=t
493
494 if test -z "$HARNESS_ACTIVE"
495 then
496 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
497 mkdir -p "$test_results_dir"
498 base=${0##*/}
499 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
500
501 cat >>"$test_results_path" <<-EOF
502 total $test_count
503 success $test_success
504 fixed $test_fixed
505 broken $test_broken
506 failed $test_failure
507
508 EOF
509 fi
510
511 if test "$test_fixed" != 0
512 then
513 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
514 fi
515 if test "$test_broken" != 0
516 then
517 say_color warn "# still have $test_broken known breakage(s)"
518 fi
519 if test "$test_broken" != 0 || test "$test_fixed" != 0
520 then
521 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
522 msg="remaining $test_remaining test(s)"
523 else
524 test_remaining=$test_count
525 msg="$test_count test(s)"
526 fi
527 case "$test_failure" in
528 0)
529 # Maybe print SKIP message
530 if test -n "$skip_all" && test $test_count -gt 0
531 then
532 error "Can't use skip_all after running some tests"
533 fi
534 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
535
536 if test $test_external_has_tap -eq 0
537 then
538 if test $test_remaining -gt 0
539 then
540 say_color pass "# passed all $msg"
541 fi
542 say "1..$test_count$skip_all"
543 fi
544
545 test -d "$remove_trash" &&
546 cd "$(dirname "$remove_trash")" &&
547 rm -rf "$(basename "$remove_trash")"
548
549 test_at_end_hook_
550
551 exit 0 ;;
552
553 *)
554 if test $test_external_has_tap -eq 0
555 then
556 say_color error "# failed $test_failure among $msg"
557 say "1..$test_count"
558 fi
559
560 exit 1 ;;
561
562 esac
563}
564
565if test -n "$valgrind"
566then
567 make_symlink () {
568 test -h "$2" &&
569 test "$1" = "$(readlink "$2")" || {
570 # be super paranoid
571 if mkdir "$2".lock
572 then
573 rm -f "$2" &&
574 ln -s "$1" "$2" &&
575 rm -r "$2".lock
576 else
577 while test -d "$2".lock
578 do
579 say "Waiting for lock on $2."
580 sleep 1
581 done
582 fi
583 }
584 }
585
586 make_valgrind_symlink () {
587 # handle only executables, unless they are shell libraries that
588 # need to be in the exec-path.
589 test -x "$1" ||
590 test "# " = "$(head -c 2 <"$1")" ||
591 return;
592
593 base=$(basename "$1")
594 symlink_target=$GIT_BUILD_DIR/$base
595 # do not override scripts
596 if test -x "$symlink_target" &&
597 test ! -d "$symlink_target" &&
598 test "#!" != "$(head -c 2 < "$symlink_target")"
599 then
600 symlink_target=../valgrind.sh
601 fi
602 case "$base" in
603 *.sh|*.perl)
604 symlink_target=../unprocessed-script
605 esac
606 # create the link, or replace it if it is out of date
607 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
608 }
609
610 # override all git executables in TEST_DIRECTORY/..
611 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
612 mkdir -p "$GIT_VALGRIND"/bin
613 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
614 do
615 make_valgrind_symlink $file
616 done
617 # special-case the mergetools loadables
618 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
619 OLDIFS=$IFS
620 IFS=:
621 for path in $PATH
622 do
623 ls "$path"/git-* 2> /dev/null |
624 while read file
625 do
626 make_valgrind_symlink "$file"
627 done
628 done
629 IFS=$OLDIFS
630 PATH=$GIT_VALGRIND/bin:$PATH
631 GIT_EXEC_PATH=$GIT_VALGRIND/bin
632 export GIT_VALGRIND
633 GIT_VALGRIND_MODE="$valgrind"
634 export GIT_VALGRIND_MODE
635 GIT_VALGRIND_ENABLED=t
636 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
637 export GIT_VALGRIND_ENABLED
638elif test -n "$GIT_TEST_INSTALLED"
639then
640 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
641 error "Cannot run git from $GIT_TEST_INSTALLED."
642 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
643 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
644else # normal case, use ../bin-wrappers only unless $with_dashes:
645 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
646 if ! test -x "$git_bin_dir/git"
647 then
648 if test -z "$with_dashes"
649 then
650 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
651 fi
652 with_dashes=t
653 fi
654 PATH="$git_bin_dir:$PATH"
655 GIT_EXEC_PATH=$GIT_BUILD_DIR
656 if test -n "$with_dashes"
657 then
658 PATH="$GIT_BUILD_DIR:$PATH"
659 fi
660fi
661GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
662GIT_CONFIG_NOSYSTEM=1
663GIT_ATTR_NOSYSTEM=1
664export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
665
666if test -z "$GIT_TEST_CMP"
667then
668 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
669 then
670 GIT_TEST_CMP="$DIFF -c"
671 else
672 GIT_TEST_CMP="$DIFF -u"
673 fi
674fi
675
676GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
677export GITPERLLIB
678test -d "$GIT_BUILD_DIR"/templates/blt || {
679 error "You haven't built things yet, have you?"
680}
681
682if ! test -x "$GIT_BUILD_DIR"/test-chmtime
683then
684 echo >&2 'You need to build test-chmtime:'
685 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
686 exit 1
687fi
688
689# Test repository
690TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
691test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
692case "$TRASH_DIRECTORY" in
693/*) ;; # absolute path is good
694 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
695esac
696test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
697rm -fr "$TRASH_DIRECTORY" || {
698 GIT_EXIT_OK=t
699 echo >&5 "FATAL: Cannot prepare test area"
700 exit 1
701}
702
703HOME="$TRASH_DIRECTORY"
704export HOME
705
706if test -z "$TEST_NO_CREATE_REPO"
707then
708 test_create_repo "$TRASH_DIRECTORY"
709else
710 mkdir -p "$TRASH_DIRECTORY"
711fi
712# Use -P to resolve symlinks in our working directory so that the cwd
713# in subprocesses like git equals our $PWD (for pathname comparisons).
714cd -P "$TRASH_DIRECTORY" || exit 1
715
716this_test=${0##*/}
717this_test=${this_test%%-*}
718if match_pattern_list "$this_test" $GIT_SKIP_TESTS
719then
720 say_color info >&3 "skipping test $this_test altogether"
721 skip_all="skip all tests in $this_test"
722 test_done
723fi
724
725# Provide an implementation of the 'yes' utility
726yes () {
727 if test $# = 0
728 then
729 y=y
730 else
731 y="$*"
732 fi
733
734 while echo "$y"
735 do
736 :
737 done
738}
739
740# Fix some commands on Windows
741case $(uname -s) in
742*MINGW*)
743 # Windows has its own (incompatible) sort and find
744 sort () {
745 /usr/bin/sort "$@"
746 }
747 find () {
748 /usr/bin/find "$@"
749 }
750 sum () {
751 md5sum "$@"
752 }
753 # git sees Windows-style pwd
754 pwd () {
755 builtin pwd -W
756 }
757 # no POSIX permissions
758 # backslashes in pathspec are converted to '/'
759 # exec does not inherit the PID
760 test_set_prereq MINGW
761 test_set_prereq NOT_CYGWIN
762 test_set_prereq SED_STRIPS_CR
763 test_set_prereq GREP_STRIPS_CR
764 GIT_TEST_CMP=mingw_test_cmp
765 ;;
766*CYGWIN*)
767 test_set_prereq POSIXPERM
768 test_set_prereq EXECKEEPSPID
769 test_set_prereq NOT_MINGW
770 test_set_prereq CYGWIN
771 test_set_prereq SED_STRIPS_CR
772 test_set_prereq GREP_STRIPS_CR
773 ;;
774*)
775 test_set_prereq POSIXPERM
776 test_set_prereq BSLASHPSPEC
777 test_set_prereq EXECKEEPSPID
778 test_set_prereq NOT_MINGW
779 test_set_prereq NOT_CYGWIN
780 ;;
781esac
782
783( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
784test -z "$NO_PERL" && test_set_prereq PERL
785test -z "$NO_PYTHON" && test_set_prereq PYTHON
786test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
787test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
788
789# Can we rely on git's output in the C locale?
790if test -n "$GETTEXT_POISON"
791then
792 GIT_GETTEXT_POISON=YesPlease
793 export GIT_GETTEXT_POISON
794 test_set_prereq GETTEXT_POISON
795else
796 test_set_prereq C_LOCALE_OUTPUT
797fi
798
799# Use this instead of test_cmp to compare files that contain expected and
800# actual output from git commands that can be translated. When running
801# under GETTEXT_POISON this pretends that the command produced expected
802# results.
803test_i18ncmp () {
804 test -n "$GETTEXT_POISON" || test_cmp "$@"
805}
806
807# Use this instead of "grep expected-string actual" to see if the
808# output from a git command that can be translated either contains an
809# expected string, or does not contain an unwanted one. When running
810# under GETTEXT_POISON this pretends that the command produced expected
811# results.
812test_i18ngrep () {
813 if test -n "$GETTEXT_POISON"
814 then
815 : # pretend success
816 elif test "x!" = "x$1"
817 then
818 shift
819 ! grep "$@"
820 else
821 grep "$@"
822 fi
823}
824
825test_lazy_prereq PIPE '
826 # test whether the filesystem supports FIFOs
827 case $(uname -s) in
828 CYGWIN*)
829 false
830 ;;
831 *)
832 rm -f testfifo && mkfifo testfifo
833 ;;
834 esac
835'
836
837test_lazy_prereq SYMLINKS '
838 # test whether the filesystem supports symbolic links
839 ln -s x y && test -h y
840'
841
842test_lazy_prereq FILEMODE '
843 test "$(git config --bool core.filemode)" = true
844'
845
846test_lazy_prereq CASE_INSENSITIVE_FS '
847 echo good >CamelCase &&
848 echo bad >camelcase &&
849 test "$(cat CamelCase)" != good
850'
851
852test_lazy_prereq UTF8_NFD_TO_NFC '
853 # check whether FS converts nfd unicode to nfc
854 auml=$(printf "\303\244")
855 aumlcdiar=$(printf "\141\314\210")
856 >"$auml" &&
857 case "$(echo *)" in
858 "$aumlcdiar")
859 true ;;
860 *)
861 false ;;
862 esac
863'
864
865test_lazy_prereq AUTOIDENT '
866 sane_unset GIT_AUTHOR_NAME &&
867 sane_unset GIT_AUTHOR_EMAIL &&
868 git var GIT_AUTHOR_IDENT
869'
870
871# When the tests are run as root, permission tests will report that
872# things are writable when they shouldn't be.
873test -w / || test_set_prereq SANITY
874
875GIT_UNZIP=${GIT_UNZIP:-unzip}
876test_lazy_prereq UNZIP '
877 "$GIT_UNZIP" -v
878 test $? -ne 127
879'